
package de.ivu.elect.business.wahlausschuss.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.wahlausschuss.entity.Wahlausschussmitglied;

@RequestScoped
@Named(WahlausschussmitgliedConversationSelect.COMPONENT_NAME)
public class WahlausschussmitgliedConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlausschussmitgliedConversationSelect";

  @Inject
  protected transient WahlausschussmitgliedExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(WahlausschussmitgliedConversationStore.class)
  protected transient WahlausschussmitgliedConversationStore conversationStore;

  public WahlausschussmitgliedConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public Wahlausschussmitglied getEntity() {
    return getEntityInternal();
  }

  private Wahlausschussmitglied getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(Wahlausschussmitglied entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(Wahlausschussmitglied entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.person.entity.PersonendatenPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.person.entity.PersonendatenPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected Wahlausschussmitglied attach(Wahlausschussmitglied entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected Wahlausschussmitglied attach( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
